/*
**	PROMOD Standards
*/

# ifdef __REQUIRED__

version.h
promsetsys.h

# endif

# if 0
VERS____( ProMod standards definition, Liv/Krz/Sei,  92/01/03)
# endif


/******************************************************************************
:++
:HEADER_FILE		"promdef.h"		"Standard Definitions"

:PURPOSE

Dieser File enth"alt Standard Macros zur Unterst"utzung des Programmier Stils.
Dazu geh"oren u.a. `TRUE`, `FALSE`, `YES`, `NO`, sowie die Grunddatentypen in
Gro"sbuchstaben.

:para
Empfohlener Stil ist es, gro"s geschriebene Datentypen zu verwenden.

:para
F"ur 'static' gibt es die Macros `STATIC`, `LOCAL`, `INTERN` und f"ur 'extern' die
Macros `EXTERN`, `GLOBAL` und `IMPORT`. Dabei sollten `STATIC` und `EXTERN` f"ur
Funktionen, `LOCAL` und `GLOBAL` f"ur Daten au"serhalb von Funktionen und `INTERN` und
`IMPORT` f"ur Daten innerhalb von Funktionen verwendet werden.

:para
F"ur Funktionen werden die Storage-Klassen `STATIC`, `SUBPUBLIC`, `PUBLIC` und
`SYSPUBLIC` definiert. Diese werden bei einem Lauf der 'proto'-Utility nach
speziellen Schl"usselw"ortern expandiert. Dazu mu"s die Pre"\pro"\zes"\sor-Var"\i"\a"\ble
'GEN_PROTO' gesetzt sein. Andernfalls wird `STATIC` nach 'static' und die anderen nach
nichts expandiert.

:para
F"ur C++ Programme m"ussen noch zus"atzliche Stilempfehlungen entwickelt werden.

:para
Dieser File darf keine 'typedef' enthalten, damit er mehrfach includiert werden
kann, bzw. damit er in Sourcen f"ur den 'rpcgen' includiert werden kann.
'typedef' Statements k"onnen ggfs. in 'promdef2.h' stehen.

:ENDPURPOSE
:--
******************************************************************************/
/*P*/
# ifdef SHORT
# undef SHORT
# endif
# ifdef LONG
# undef LONG
# endif
# ifdef LONG32
# undef LONG32
# endif
# ifdef LONG64
# undef LONG64
# endif
# ifdef INT
# undef INT
# endif
# ifdef INT32
# undef INT32
# endif
# ifdef INT64
# undef INT64
# endif
# ifdef DOUBLE
# undef DOUBLE
# endif
# ifdef FLOAT
# undef FLOAT
# endif
# ifdef REAL
# undef REAL
# endif
# ifdef BYTE
# undef BYTE
# endif
# ifdef USHORT
# undef USHORT
# endif
# ifdef UINT
# undef UINT
# endif
# ifdef UINT32
# undef UINT32
# endif
# ifdef UINT64
# undef UINT64
# endif
# ifdef ULONG
# undef ULONG
# endif
# ifdef ULONG32
# undef ULONG32
# endif
# ifdef ULONG64
# undef ULONG64
# endif
# ifdef TEXT
# undef TEXT
# endif
# ifdef BOOL
# undef BOOL
# endif

/*P*/
# if ALPHA
#  define LONG32	int
#  define ULONG32	unsigned int
#  define LONG64	long
#  define ULONG64	unsigned long
#  define INT32		int
#  define UINT32	unsigned int
#  define INT64		long
#  define UINT64	unsigned long
# else
#  define LONG32	long
#  define ULONG32	unsigned long
#  define LONG64	undefined
#  define ULONG64	undefined
#  define INT32		int
#  define UINT32	unsigned int
#  define INT64		undefined
#  define UINT64	undefined
# endif


# define SHORT		short
# define LONG		long
# define INT		int
# define DOUBLE		double
# define FLOAT		float
# define REAL		float
# define BYTE		unsigned char
# define USHORT		unsigned short
# define UINT		unsigned int
# define ULONG		unsigned long
# define TEXT		char
# define _		(TEXT *)
# define BOOL		int

# define STATUS		unsigned long
# define OFFSET		unsigned short
# define LOFFSET        unsigned long
# define UINT		unsigned int
# define SZ		sizeof

# define IMPORT		extern
# define GLOBAL		extern C_PUBLIC
# define PRIVATE        static
# define EXTERN		extern

# define STATIC		static
# define INTERN		static
# define LOCAL		static

# ifdef GEN_PROTO
# define SUBPUBLIC 	__intern$
# define PUBLIC 	__intern$
# define SYSPUBLIC   	__extern$
# define DISABLE	__disabl$
# else
# define SUBPUBLIC
# define PUBLIC
# define SYSPUBLIC
# define DISABLE
# endif

# define MEMBER
# define VIRTUAL	virtual
# define INLINE         inline

# ifndef VOID
# define VOID		void
# endif
/*P*/

# ifdef TRUE
# undef TRUE
# endif

# ifdef FALSE
# undef FALSE
# endif

# ifdef NULL
# undef NULL
# endif

# ifdef MAX
# undef MAX
# endif

# ifdef MIN
# undef MIN
# endif

# ifdef max
# undef max
# endif

# ifdef min
# undef min
# endif

# define FAST		register
# define YES		1
# define NO		0
# define OK		1
# define TRUE		1
# define FALSE		0
# define NULL		0
# define MAX( a, b)     ((a) > (b) ? (a) : (b))
# define MIN( a, b)     ((a) < (b) ? (a) : (b))

# define SGN( x)	((x) > 0) ? 1 :(((x) < 0) ? -1 : 0)
# define GET_ADDRESS( adr, off)    ((BYTE *)(adr) + (off))
# define STRUCT_ALLOC( type) 	   ((type *) clb_malloc( sizeof( type)))
# define STRUCT_OFFSET( type, field)  ((LONG)&(( type *)0)->field)
# define STRUCTA_OFFSET( type, array_field)  ((LONG)(( type *)0)->array_field)
# define USE( var)	var = var

# define LOOPBREAK      break
# define CASEBREAK      break
# ifndef FOREVER
# define FOREVER	for(;;)
# endif

